<template>
    <div class="container">
        <div class="head">
            <img :src="logo" alt="">
        </div>
        <div class="main">
            <div class="btn" @click="login()">登 录</div>
            <div class="btn" @click="register()">注 册</div>
            <div class="btn wx" @click="wxLogin()"><img :src="wxlogo" alt="">微信账号登录</div>
        </div>
    </div>
</template>

<script>
import logo from '@/assets/logo.png'
import wxlogo from '@/assets/wx.png'
import utils from '@/api/util'
import { Toast } from 'vant'
import wx from 'weixin-jsapi'

export default {
  name: 'First',
  data () {
    return {
      logo,
      wxlogo,
      videoSrc: '',
    }
  },
  mounted: async function(){
  },
  methods: {
    login () {
      this.$router.push('/login')
    },
    register () {
      this.$router.push('/register')
    },
    wxLogin () {
      var AppId = 'wx1c133c39f443da81'
      var code = utils.getUrlKey('code')
      var local = window.location.href
      var Signature = ''
      var Timestamp = ''
      var NonceStr = ''
      var TICKET = ''
      if (code == null || code === '') {
        //拿不到code，刷新页面继续
        console.log('code:', code)
      } else {
        this.$api.wxlogin(code)
          .then(res => {
            console.log(res.data.data.id)
            localStorage.setItem('userId', res.data.data.id)
            Toast('登录成功')
            this.$router.push('/index')
            return this.$api.myInfo()
          }).then(res => {
            this.$store.commit('userInfo/setUserInfo', res.data.data)
            console.log(this.$store.state.userInfo.detail.userId)
          }).catch(() => {
            Toast('登录失败')
          })
      }
      this.$api.getWxConfig()
        .then(res => {
          console.log(res.data)
          if (res.data.errcode === 0) {
            TICKET = res.data.ticket
            NonceStr = utils.getRanArr(true, 15, 32)
            Timestamp = (new Date()).valueOf()
            console.log(utils.getCrtUrl())
            Signature = utils.getSign(TICKET, NonceStr, Timestamp, utils.getCrtUrl())
            wxConfig()
          } else {
            Toast(res.data.errmsg)
          }
        }).catch(() => {
          console.log('获取TICKET失败')
        })
      function wxConfig () {
        wx.config({
          debug: true,// 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
          appId: AppId, // 必填，公众号的唯一标识
          timestamp: Timestamp, // 必填，生成签名的时间戳
          nonceStr: NonceStr, // 必填，生成签名的随机串
          signature: Signature,// 必填，签名
          jsApiList: ['openLocation', 'getLocation', 'closeWindow', 'checkJsApi'] //
        });

        wx.ready(function () {
          var latitude;
          var longitude;
          var accuracy;
          wx.config({
            debug: true,// 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
            appId: AppId, // 必填，公众号的唯一标识
            timestamp: Timestamp, // 必填，生成签名的时间戳
            nonceStr: NonceStr, // 必填，生成签名的随机串
            signature: Signature,// 必填，签名
            jsApiList: ['openLocation', 'getLocation', 'closeWindow', 'checkJsApi'] //
          });
          wx.checkJsApi({
            jsApiList: ['getLocation'], // 需要检测的JS接口列表，所有JS接口列表见附录2,
            success: function (res) {
              alert('dsgsdag' + res.checkResult.getLocation);
              if (res.checkResult.getLocation === false) {
                alert("你的微信版本太低，不支持微信JS接口，请升级到最新的微信版本！");
              }
            }
          });
          // config信息验证后会执行ready方法，所有接口调用都必须在config接口获得结果之后，config是一个客户端的异步操作，所以如果需要在页面加载时就调用相关接口，则须把相关接口放在ready函数中调用来确保正确执行。对于用户触发时才调用的接口，则可以直接调用，不需要放在ready函数中。
          // 以认证成功进行定位为例说明；
          try {
            wx.getLocation({
              success: function (res) {
                alert('getLoc success');
                latitude = res.latitude; // 纬度，浮点数，范围为90 ~ -90
                longitude = res.longitude; // 经度，浮点数，范围为180 ~ -180。
                accuracy = res.accuracy; // 位置精度
              },
              fail: function (res) {
                alert('wx.getL fail');
                _self.$dialog.alert({
                  message: '定位失效，请手动选择'
                }).then(function () {
                  _self.$router.push('location');
                })
              },
              cancel: function (res) {
                alert('getLoc cancel');
                wx.closeWindow();
              },
              complete: function (res) {
                alert('complete');
              }
            });
          } catch (e) {
            alert(e);
          }
        });
        wx.error(function (res) {
          // config信息验证失败会执行error函数，如签名过期导致验证失败，具体错误信息可以打开config的debug模式查看，也可以在返回的res参数中查看，对于SPA可以在这里更新签名。
          _self.$dialog.alert({
            message: '微信认证失败，请重试'
          }).then(function () {
            wx.closeWindow();
          })
        });
      }
    }
  }
}
</script>
<style scoped lang="less">
    .container{
        height:100vh;
        background: #3170ff;
        .head{
            padding: 130.5px 33.6% 0 36.53%;
            img{
                width: 112px;
                height:139px;
            }
        }
        .main{
            padding: 145px 23.87% 23.87%;
            .btn{
                display: flex;
                align-items: center;
                justify-content: center;
                background: #fff;
                border-radius: 4px;
                height:41.5px;
                color: #3170ff;
                font-size: 17.5px;
                letter-spacing:12px;
                text-indent: 12px;
                font-weight: bold;
                margin-bottom:11px;
                &.wx{
                    display: flex;
                    flex-direction: row;
                    align-items: center;
                    justify-content: center;
                    background: #80D541;
                    color: #fff;
                    font-size:16px;
                    letter-spacing:3px;
                    text-indent: 3px;
                    img{
                        width: 23px;
                        height:18.5px;
                        margin-right: 7.1%;
                    }
                }
            }
        }
    }
</style>
